EDIT - bug #9483

LazylnitializationException (LIE) in TaxonNamePopupEditor when selecting trinominal rank
02/26/2021 02:27 PM - Andreas Kohlbecker

Status: Closed Start date:

Priority: Highest Due date:

Assignee: Andreas Kohlbecker % Done: 100%
Category: cdm-vaadin Estimated time: 0:00 hour
Target version: Release 5.21

Severity: normal Found in Version:

Description

The LIE occurs in public String rankSpecificNamePart() at rank.isHigher(Rank.GENUS()) which internally calls
OrderedTermBase.performCompareTo(T thatTerm, boolean skipVocabularyCheck) where the vocabulary is required for comparison.
The rank.vocabulary is not initialized in the case covered by this ticket.

Related issues:
Copied to EDIT - task #9490: avoid rank entity in TaxonNameParts Closed

Associated revisions

Revision e20135dc - 02/26/2021 02:37 PM - Andreas Kohlbecker

fix #9483 adapting bean initialization in .TaxonNameDaoHibernatelmpl.prepareFindTaxonNameParts(..) to new? rank compare

Revision d10e9a39 - 03/01/2021 03:10 PM - Andreas Kohlbecker

fix #9483 initializing rank.vocabulary in the TaxonNameParts constructor

Revision a05e4acf - 03/01/2021 03:21 PM - Andreas Kohlbecker

fix #9483 initializing rank.vocabulary in the TaxonNameParts constructor - comment

Revision 6d804466 - 03/01/2021 05:23 PM - Andreas Kohlbecker
fix #9483 better solution by using rankClass only

Revision 520afc6d - 03/01/2021 05:35 PM - Andreas Kohlbecker

fix #9483 better solution by using rankClass only - restoring chanches after merge with previous cleanup

History

#1 - 02/26/2021 02:38 PM - Andreas Kohlbecker
- Status changed from New to Resolved

- % Done changed from 0 to 50

Applied in changeset cdmlible20135dca8ba5443b97814e31ad18cdc93036865.

#2 - 02/26/2021 03:40 PM - Andreas Kohlbecker

- Assignee changed from Andreas Kohlbecker to Wolf-Henning Kusber

please review

#3 - 02/26/2021 05:57 PM - Wolf-Henning Kusber

- Assignee changed from Wolf-Henning Kusber to Andreas Kohlbecker

Review: Internal error when selecting variety of form, instead of opening a third field for the last epithet.

#4 - 03/01/2021 03:08 PM - Andreas Kohlbecker

Usually we are passing initStrategies to the service methods in order to initialize associated entities. In this case this way would not be appropriate

since the method causing the LIE is member method of the Class which is being used in a select new {constructor} expression.
Therefore the proper most solution for this problem would be to initialize the rank.vocabulary directly in the TaxonNameDaoHibernatelmpl.
This however is not (yet?) working due to a specific interpretation of the JPA language specs: https:/hibernate.atlassian.net/browse/HHH-3345 so the
following code will not work:

private StringBuilder prepareFindTaxonNameParts (boolean doCount, Optional<String> genusOrUninomial,
Optional<String> infraGenericEpithet, Optional<String> specificEpithet,
Optional<String> infraSpecificEpithet, Rank rank, Collection<UUID> excludedNamesUuids) {

StringBuilder hgl = new StringBuilder();
if (doCount) {
hgl.append("select count(n.id) ");
} else {
hqgl.append (
"select new eu.etaxonomy.cdm.persistence.dto.TaxonNameParts(n.id, n.uuid, n.rank, n.genusOrUninomial, n.infraG
enericEpithet, n.specificEpithet, n.infraSpecificEpithet) ");
}
hgl.append ("from TaxonName n ");
if (!doCount) {

// >>>>>>>>>>>>>> need to initialize the ranks with vocabulary to avoid LIEs in TaxonNameParts.rankSpecificNam
ePart () see #9483
// >>>>>>>>>>>>>> This will not work due to HHH-3345
hgl.append("left join fetch n.rank as r left join fetch r.vocabulary as v ");
}
hgl.append("where 1 =1 ");

if (rank != null) {
hgl.append("and n.rank = :rank ");

}

if (excludedNamesUuids != null && excludedNamesUuids.size () > 0) {
hgl.append("and n.uuid not in ( :excludedNamesUuids ) ");

addFieldPredicate (hgl, "n.genusOrUninomial", genusOrUninomial);
addFieldPredicate (hgl, "n.infraGenericEpithet", infraGenericEpithet);
addFieldPredicate (hgl, "n.specificEpithet", specificEpithet);
addFieldPredicate (hgl, "n.infraSpecificEpithet", infraSpecificEpithet);

return hqgl;

Therefore | decided to initialize the rank.vocabulary in the constructor:

public TaxonNameParts (Integer taxonNameId, UUID taxonNameUuid, Rank rank, String genusOrUninomial, String
infraGenericEpithet,
String specificEpithet, String infraSpecificEpithet) {
super () ;
this.taxonNameId = taxonNamelId;
this.taxonNameUuid = taxonNameUuid;
this.rank = rank;
if (rank != null) {
HibernateBeanInitializer.initialize (rank.getVocabulary());

this.genusOrUninomial = genusOrUninomial;
this.infraGenericEpithet = infraGenericEpithet;

this.specificEpithet = specificEpithet;
this.infraSpecificEpithet = infraSpecificEpithet;

#5 - 03/01/2021 03:11 PM - Andreas Kohlbecker

- Assignee changed from Andreas Kohlbecker to Wolf-Henning Kusber
Hi Henning, this issue can be reviewed again.

#6 - 03/01/2021 04:36 PM - Andreas Kohlbecker

- Description updated

#7 - 03/01/2021 04:50 PM - Andreas Kohlbecker
- Copied to task #9490: avoid rank entity in TaxonNameParts added

#8 - 03/01/2021 04:50 PM - Andreas Kohlbecker

new ticket for possibly better solution #9490
#9 - 03/01/2021 05:58 PM - Wolf-Henning Kusber
- Assignee changed from Wolf-Henning Kusber to Andreas Kohlbecker

- % Done changed from 50 to 100

Trinominals can be created and stored. If this is due to #9483 this ticket can be closed.

#10 - 03/02/2021 09:36 AM - Andreas Kohlbecker

- Status changed from Resolved to Closed
